' *******************************************************************
' ** Name:    MSTRUCT.H                                            **
' ** Usage:   Include File to AdlPLAY.BAS                          **
' ** Author:  Joseph Scally                                        **
' ** Date  :  June 89                                              **
' *******************************************************************

'This File contains Data structures to read an .ROL files as well
'as some other structures used in the program and declares variables
'of the types defined .


' ***************** Actual Header of a ROL file  ********************
TYPE MusicHeader
              MajorVersion        AS INTEGER         'File  Signature
              MinorVersion        AS INTEGER         '
              F1                  AS STRING * 40     'Filler
              TicksPerBeat        AS INTEGER         'Ticks
              BeatsPerMeasure     AS INTEGER         'Beats
              EditXAxis           AS INTEGER         'Used By Composer
              EditYAxis           AS INTEGER         'Used by composer
              F2                  AS STRING * 1      'Filler
              Mode                AS STRING * 1      'Melodic 0 / Percussive 1
              F3                  AS STRING * 90     'Filler
              F4                  AS STRING * 38     'Filler
              F5                  AS STRING * 15     'Filler
              Tempo               AS SINGLE          'Floating Point
              TEvents             AS INTEGER         'Time in Ticks of Tempo Event
END TYPE
'  **********************************************************************************


TYPE Vheader
              Vfiller             AS STRING * 15
              Vduration           AS INTEGER
END TYPE


TYPE Fnote
              Note                AS INTEGER
              Duration            AS INTEGER
END TYPE
TYPE Afill
              AfterFiller         AS STRING * 15
END TYPE

TYPE Evnt
              NumEvents           AS INTEGER
END TYPE

TYPE InsEvent
              TimeInTicks         AS INTEGER
              InstrumentName      AS STRING * 9
              Junk                AS STRING * 1
              Ijunk               AS INTEGER
END TYPE

TYPE VolEvent

              TimeEvent           AS INTEGER
              VolMultiplier       AS SINGLE
END TYPE
TYPE Tevent
              TimeEvent           AS INTEGER
              Tmultiplier         AS SINGLE
END TYPE

TYPE RegType
     ax    AS INTEGER
     bx    AS INTEGER
     cx    AS INTEGER
     dx    AS INTEGER
     bp    AS INTEGER
     si    AS INTEGER
     di    AS INTEGER
     flags AS INTEGER
END TYPE


DIM Mh AS MusicHeader
DIM VoiceHeader AS Vheader
DIM Pnote AS Fnote
DIM Af AS Afill
DIM NuminstruEvents AS Evnt
DIM NumVolEvents AS Evnt
DIM NumPitchEvents AS Evnt
DIM InstrumentEvent AS InsEvent
DIM VolumeEvent AS VolEvent
DIM PitchEvent  AS VolEvent
DIM TempoEvent AS Tevent
DIM SHARED InRegs AS RegType
DIM SHARED OutRegs AS RegType

